"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const settings_1 = require("./settings");
const config_1 = require("./config");
exports.THEME_STATE = "dokiThemeState";
const reducer = (state, action) => {
    switch (action.type) {
        case settings_1.SET_THEME: {
            const previousState = state[exports.THEME_STATE] || {};
            const themeState = Object.assign(Object.assign({}, previousState), { activeTheme: action.payload, currentSticker: {
                    type: previousState.currentSticker.type,
                    sticker: config_1.getCorrectSticker(action.payload, previousState.currentSticker.type),
                } });
            return state.set(exports.THEME_STATE, themeState);
        }
        case settings_1.SET_STICKER_TYPE: {
            const previousState = state[exports.THEME_STATE] || {};
            const themeState = Object.assign(Object.assign({}, previousState), { currentSticker: {
                    type: action.payload,
                    sticker: config_1.getCorrectSticker(previousState.activeTheme, action.payload),
                } });
            return state.set(exports.THEME_STATE, themeState);
        }
        case settings_1.TOGGLE_STICKER: {
            const previousState2 = state[exports.THEME_STATE] || {};
            const themeState = Object.assign(Object.assign({}, previousState2), { showSticker: !state[exports.THEME_STATE].showSticker });
            return state.set(exports.THEME_STATE, themeState);
        }
        case settings_1.TOGGLE_WALLPAPER: {
            const previousState2 = state[exports.THEME_STATE] || {};
            const themeState = Object.assign(Object.assign({}, previousState2), { showWallpaper: !state[exports.THEME_STATE].showWallpaper });
            return state.set(exports.THEME_STATE, themeState);
        }
        case "INIT": {
            const { theme, sticker } = config_1.getTheme();
            const themeState = {
                activeTheme: theme,
                currentSticker: sticker,
                showSticker: config_1.extractConfig().showSticker,
                showWallpaper: config_1.extractConfig().showWallpaper,
            };
            return state.set(exports.THEME_STATE, themeState);
        }
        default: {
            return state;
        }
    }
};
exports.default = reducer;
//# sourceMappingURL=reducer.js.map